Index: trunk/source/Lib/TLibCommon/SEI.h
===================================================================
--- trunk/source/Lib/TLibCommon/SEI.h	(revision 1357)
+++ trunk/source/Lib/TLibCommon/SEI.h	(revision 1386)
@@ -44,5 +44,5 @@
 
 
-#if NH_MV_SEI
+#if NH_MV
 #include "TAppCommon/program_options_lite.h"
 using namespace std;
@@ -53,5 +53,5 @@
 //! \{
 class TComSPS;
-#if NH_MV_SEI
+#if NH_MV
 class TComSlice;
 class SEIScalableNesting;
@@ -94,8 +94,7 @@
     SEGM_RECT_FRAME_PACKING              = 138,
     TEMP_MOTION_CONSTRAINED_TILE_SETS    = 139,
-    CHROMA_SAMPLING_FILTER_HINT          = 140,
-    KNEE_FUNCTION_INFO                   = 141
-#if NH_MV_SEI
-    ,COLOUR_REMAPPING_INFO                    = 142,
+    CHROMA_RESAMPLING_FILTER_HINT        = 140,
+    KNEE_FUNCTION_INFO                   = 141,
+    COLOUR_REMAPPING_INFO                = 142,
     DEINTERLACED_FIELD_IDENTIFICATION         = 143,
     LAYERS_NOT_PRESENT                        = 160,
@@ -116,16 +115,22 @@
     ,ALTERNATIVE_DEPTH_INFO                    = 181
 #endif
+
+  };
+
+#if NH_MV
+  SEI();
+#else
+  SEI() {}
 #endif
 
-  };
-
-  SEI();
 
   virtual ~SEI() {}
+
+  static const TChar *getSEIMessageString(SEI::PayloadType payloadType);
+
+  virtual PayloadType payloadType() const = 0;
+
+#if NH_MV
   virtual SEI*       getCopy( ) const;
-  static const Char *getSEIMessageString(SEI::PayloadType payloadType );
-  virtual PayloadType payloadType() const = 0;
-
-#if NH_MV_SEI
   static SEI*        getNewSEIMessage         ( SEI::PayloadType payloadType );
   Bool               insertSei                ( Int curLayerId, Int curPoc, Int curTid, Int curNaluType ) const;
@@ -133,10 +138,10 @@
 
   virtual Void       setupFromSlice           ( const TComSlice* slice );
-  virtual Void       setupFromCfgFile         ( const Char* cfgFile );
+  virtual Void       setupFromCfgFile         ( const TChar*   cfgFile );
   virtual Bool       checkCfg                 ( const TComSlice* slice   );
 
   Void               xPrintCfgErrorIntro();
-  Void               xCheckCfgRange           ( Bool& wrongConfig, Int val, Int minVal, Int maxVal, const Char* seName );
-  Void               xCheckCfg                ( Bool& wrongConfig, Bool cond, const Char* errStr );
+  Void               xCheckCfgRange           ( Bool& wrongConfig, Int val, Int minVal, Int maxVal, const TChar* seName );
+  Void               xCheckCfg                ( Bool& wrongConfig, Bool cond, const TChar* errStr );
   Void               xAddGeneralOpts          ( po::Options &opts, IntAry1d defAppLayerIds, IntAry1d defAppPocs, IntAry1d defAppTids, IntAry1d defAppVclNaluTypes,
                                                 Int defSeiNaluId, Int defPositionInSeiNalu, Bool defModifyByEncoder );
@@ -186,11 +191,5 @@
   virtual ~SEIDecodedPictureHash() {}
 
-  enum Method
-  {
-    MD5,
-    CRC,
-    CHECKSUM,
-    RESERVED,
-  } method;
+  HashType method;
 
   TComPictureHash m_pictureHash;
@@ -482,41 +481,60 @@
 };
 
-class SEIChromaSamplingFilterHint : public SEI
-{
-public:
-  PayloadType payloadType() const {return CHROMA_SAMPLING_FILTER_HINT;}
-  SEIChromaSamplingFilterHint() {}
-  virtual ~SEIChromaSamplingFilterHint() {
-    if(m_verChromaFilterIdc == 1)
+class SEIColourRemappingInfo : public SEI
+{
+public:
+
+  struct CRIlut
+  {
+    Int codedValue;
+    Int targetValue;
+    bool operator < (const CRIlut& a) const
     {
-      for(Int i = 0; i < m_numVerticalFilters; i ++)
+      return codedValue < a.codedValue;
+    }
+  };
+
+  PayloadType payloadType() const { return COLOUR_REMAPPING_INFO; }
+  SEIColourRemappingInfo() {}
+  ~SEIColourRemappingInfo() {}
+
+  Void copyFrom( const SEIColourRemappingInfo &seiCriInput)
       {
-        free(m_verFilterCoeff[i]);
-      }
-      free(m_verFilterCoeff);
-      free(m_verTapLengthMinus1);
-    }
-    if(m_horChromaFilterIdc == 1)
-    {
-      for(Int i = 0; i < m_numHorizontalFilters; i ++)
-      {
-        free(m_horFilterCoeff[i]);
-      }
-      free(m_horFilterCoeff);
-      free(m_horTapLengthMinus1);
-    }
+    (*this) = seiCriInput;
   }
+
+  UInt                m_colourRemapId;
+  Bool                m_colourRemapCancelFlag;
+  Bool                m_colourRemapPersistenceFlag;
+  Bool                m_colourRemapVideoSignalInfoPresentFlag;
+  Bool                m_colourRemapFullRangeFlag;
+  Int                 m_colourRemapPrimaries;
+  Int                 m_colourRemapTransferFunction;
+  Int                 m_colourRemapMatrixCoefficients;
+  Int                 m_colourRemapInputBitDepth;
+  Int                 m_colourRemapBitDepth;
+  Int                 m_preLutNumValMinus1[3];
+  std::vector<CRIlut> m_preLut[3];
+  Bool                m_colourRemapMatrixPresentFlag;
+  Int                 m_log2MatrixDenom;
+  Int                 m_colourRemapCoeffs[3][3];
+  Int                 m_postLutNumValMinus1[3];
+  std::vector<CRIlut> m_postLut[3];
+};
+
+class SEIChromaResamplingFilterHint : public SEI
+{
+public:
+  PayloadType payloadType() const {return CHROMA_RESAMPLING_FILTER_HINT;}
+  SEIChromaResamplingFilterHint() {}
+  virtual ~SEIChromaResamplingFilterHint() {}
 
   Int   m_verChromaFilterIdc;
   Int   m_horChromaFilterIdc;
-  Bool  m_verFilteringProcessFlag;
+  Bool                           m_verFilteringFieldProcessingFlag;
   Int   m_targetFormatIdc;
   Bool  m_perfectReconstructionFlag;
-  Int   m_numVerticalFilters;
-  Int*  m_verTapLengthMinus1;
-  Int** m_verFilterCoeff;
-  Int   m_numHorizontalFilters;
-  Int*  m_horTapLengthMinus1;
-  Int** m_horFilterCoeff;
+  std::vector<std::vector<Int> > m_verFilterCoeff;
+  std::vector<std::vector<Int> > m_horFilterCoeff;
 };
 
@@ -530,25 +548,4 @@
     TComSEIMasteringDisplay values;
 };
-
-#if NH_MV
-#if !NH_MV_SEI
-class SEISubBitstreamProperty : public SEI
-{
-public:
-  PayloadType payloadType() const { return SUB_BITSTREAM_PROPERTY; }
-
-  SEISubBitstreamProperty():   m_activeVpsId(-1), m_numAdditionalSubStreams(0) {}
-  virtual ~SEISubBitstreamProperty() {}
-
-  Int  m_activeVpsId;
-  Int  m_numAdditionalSubStreams;
-  std::vector<Int>  m_subBitstreamMode;
-  std::vector<Int>  m_outputLayerSetIdxToVps;
-  std::vector<Int>  m_highestSublayerId;
-  std::vector<Int>  m_avgBitRate;
-  std::vector<Int>  m_maxBitRate;
-};
-#endif
-#endif
 
 typedef std::list<SEI*> SEIMessages;
@@ -658,7 +655,5 @@
 
 };
-
-#if NH_MV_SEI
-#if NH_MV_LAYERS_NOT_PRESENT_SEI
+#if NH_MV
 class SEILayersNotPresent : public SEI
 {
@@ -669,5 +664,5 @@
   SEI* getCopy( ) const { return new SEILayersNotPresent(*this); };
 
-  Void setupFromCfgFile( const Char*      cfgFile );
+  Void setupFromCfgFile( const TChar*     cfgFile );
   Bool checkCfg        ( const TComSlice* slice   );
 
@@ -681,5 +676,4 @@
   }
 };
-#endif
 
 class SEIInterLayerConstrainedTileSets : public SEI
@@ -691,5 +685,5 @@
   SEI* getCopy( ) const { return new SEIInterLayerConstrainedTileSets(*this); };
 
-  Void setupFromCfgFile( const Char*      cfgFile );
+  Void setupFromCfgFile( const TChar*     cfgFile );
   Bool checkCfg        ( const TComSlice* slice   );
 
@@ -733,5 +727,5 @@
   SEI* getCopy( ) const { return new SEIBspNesting(*this); };
 
-  Void setupFromCfgFile( const Char*      cfgFile );
+  Void setupFromCfgFile( const TChar*      cfgFile );
   Void setupFromSlice  ( const TComSlice* slice   );
   Bool checkCfg        ( const TComSlice* slice   );
@@ -752,5 +746,5 @@
   SEI* getCopy( ) const { return new SEIBspInitialArrivalTime(*this); };
 
-  Void setupFromCfgFile( const Char*      cfgFile );
+  Void setupFromCfgFile( const TChar*      cfgFile );
   Void setupFromSlice  ( const TComSlice* slice   );
   Bool checkCfg        ( const TComSlice* slice   );
@@ -769,5 +763,5 @@
   SEI* getCopy( ) const { return new SEISubBitstreamProperty(*this); };
 
-  Void setupFromCfgFile( const Char*      cfgFile );
+  Void setupFromCfgFile( const TChar*     cfgFile );
   Bool checkCfg        ( const TComSlice* slice   );
   Void resizeArrays    ( );
@@ -790,5 +784,5 @@
   SEI* getCopy( ) const { return new SEIAlphaChannelInfo(*this); };
 
-  Void setupFromCfgFile( const Char*      cfgFile );
+  Void setupFromCfgFile( const TChar*     cfgFile );
   Bool checkCfg        ( const TComSlice* slice   );
 
@@ -811,5 +805,5 @@
   SEI* getCopy( ) const { return new SEIOverlayInfo(*this); };
 
-  Void setupFromCfgFile( const Char*      cfgFile );
+  Void setupFromCfgFile( const TChar*     cfgFile );
   Bool checkCfg        ( const TComSlice* slice   );
 
@@ -848,5 +842,5 @@
   SEI* getCopy( ) const { return new SEITemporalMvPredictionConstraints(*this); };
 
-  Void setupFromCfgFile( const Char*      cfgFile );
+  Void setupFromCfgFile( const TChar*     cfgFile );
   Bool checkCfg        ( const TComSlice* slice   );
 
@@ -864,5 +858,5 @@
   SEI* getCopy( ) const { return new SEIFrameFieldInfo(*this); };
 
-  Void setupFromCfgFile( const Char*      cfgFile );
+  Void setupFromCfgFile( const TChar*     cfgFile );
   Void setupFromSlice  ( const TComSlice* slice   );
   Bool checkCfg        ( const TComSlice* slice   );
@@ -882,5 +876,5 @@
   SEI* getCopy( ) const { return new SEIThreeDimensionalReferenceDisplaysInfo(*this); };
 
-  Void setupFromCfgFile( const Char*      cfgFile );
+  Void setupFromCfgFile( const TChar*     cfgFile );
   Bool checkCfg        ( const TComSlice* slice   );
 
@@ -924,5 +918,4 @@
 };
 
-#if SEI_DRI_F0169
 class SEIDepthRepresentationInfo : public SEI
 {
@@ -936,5 +929,5 @@
         SEI* getCopy( ) const { return new SEIDepthRepresentationInfo(*this); };
 
-        Void setupFromCfgFile( const Char*      cfgFile );
+        Void setupFromCfgFile( const TChar*     cfgFile );
         Void setupFromSlice  ( const TComSlice* slice   );
         Bool checkCfg        ( const TComSlice* slice   );
@@ -993,5 +986,5 @@
         IntAry2d       m_depth_nonlinear_representation_model;
 };
-#endif
+
 
 class SEIMultiviewSceneInfo : public SEI
@@ -1003,5 +996,5 @@
   SEI* getCopy( ) const { return new SEIMultiviewSceneInfo(*this); };
 
-  Void setupFromCfgFile( const Char*      cfgFile );
+  Void setupFromCfgFile( const TChar*     cfgFile );
   Bool checkCfg        ( const TComSlice* slice   );
 
@@ -1019,5 +1012,5 @@
   SEI* getCopy( ) const { return new SEIMultiviewAcquisitionInfo(*this); };
 
-  Void setupFromCfgFile( const Char*      cfgFile );
+  Void setupFromCfgFile( const TChar*     cfgFile );
   Bool checkCfg        ( const TComSlice* slice   );
 
@@ -1131,5 +1124,5 @@
   SEI* getCopy( ) const { return new SEIMultiviewViewPosition(*this); };
 
-  Void setupFromCfgFile( const Char*      cfgFile );
+  Void setupFromCfgFile( const TChar*     cfgFile );
   Void setupFromSlice  ( const TComSlice* slice   );
   Bool checkCfg        ( const TComSlice* slice   );
@@ -1148,5 +1141,5 @@
   SEI* getCopy( ) const { return new SEIAlternativeDepthInfo(*this); };
 
-  Void setupFromCfgFile( const Char*      cfgFile );
+  Void setupFromCfgFile( const TChar*     cfgFile );
   Bool checkCfg        ( const TComSlice* slice   );
 
@@ -1357,5 +1350,5 @@
 #endif
 #endif
-
 #endif
+
 //! \}
Index: trunk/source/Lib/TLibCommon/TComBitStream.cpp
===================================================================
--- trunk/source/Lib/TLibCommon/TComBitStream.cpp	(revision 1357)
+++ trunk/source/Lib/TLibCommon/TComBitStream.cpp	(revision 1386)
@@ -93,7 +93,7 @@
 }
 
-Char* TComOutputBitstream::getByteStream() const
-{
-  return (Char*) &m_fifo.front();
+UChar* TComOutputBitstream::getByteStream() const
+{
+  return (UChar*) &m_fifo.front();
 }
 
@@ -260,5 +260,5 @@
   m_numBitsRead += uiNumberOfBits;
 
-#if ENC_DEC_TRACE && H_MV_ENC_DEC_TRAC
+#if ENC_DEC_TRACE && NH_MV_ENC_DEC_TRAC
   if ( g_traceBitsRead )
   {
Index: trunk/source/Lib/TLibCommon/TComBitStream.h
===================================================================
--- trunk/source/Lib/TLibCommon/TComBitStream.h	(revision 1357)
+++ trunk/source/Lib/TLibCommon/TComBitStream.h	(revision 1386)
@@ -115,5 +115,5 @@
    * bytestream are stored in ascending addresses.
    */
-  Char* getByteStream() const;
+  UChar* getByteStream() const;
 
   /**
Index: trunk/source/Lib/TLibCommon/TComCodingStatistics.h
===================================================================
--- trunk/source/Lib/TLibCommon/TComCodingStatistics.h	(revision 1357)
+++ trunk/source/Lib/TLibCommon/TComCodingStatistics.h	(revision 1386)
@@ -120,7 +120,7 @@
 };
 
-static inline const Char* getName(TComCodingStatisticsType name)
+static inline const TChar* getName(TComCodingStatisticsType name)
 {
-  static const Char *statNames[]=
+  static const TChar *statNames[]=
   {
     "NAL_UNIT_TOTAL_BODY", // This is a special case and is not included in the total sums.
@@ -189,5 +189,5 @@
 #endif
   };
-  assert(STATS__NUM_STATS == sizeof(statNames)/sizeof(Char *) && name < STATS__NUM_STATS);
+  assert(STATS__NUM_STATS == sizeof(statNames)/sizeof(TChar *) && name < STATS__NUM_STATS);
   return statNames[name];
 }
@@ -229,8 +229,8 @@
   }
 
-  static const Char *GetSubClassString(const UInt subClass)
+  static const TChar *GetSubClassString(const UInt subClass)
   {
     assert (subClass<CODING_STATS_NUM_SUBCLASSES);
-    static const Char *strings[1+MAX_NUM_COMPONENT+MAX_NUM_CHANNEL_TYPE]={"-", "Y", "Cb", "Cr", "Luma", "Chroma"};
+    static const TChar *strings[1+MAX_NUM_COMPONENT+MAX_NUM_CHANNEL_TYPE]={"-", "Y", "Cb", "Cr", "Luma", "Chroma"};
     return strings[subClass/CODING_STATS_NUM_WIDTHS];
   }
@@ -289,5 +289,5 @@
     { }
 
-    static Void OutputLine(const Char *pName, const Char sep, UInt width, const Char *pSubClassStr, const SStat &sCABAC, const SStat &sEP)
+    static Void OutputLine(const TChar *pName, const TChar sep, UInt width, const TChar *pSubClassStr, const SStat &sCABAC, const SStat &sEP)
     {
       if (width==0)
@@ -302,5 +302,5 @@
       }
     }
-    static Void OutputLine(const Char *pName, const Char sep, const Char *pWidthString, const Char *pSubClassStr, const SStat &sCABAC, const SStat &sEP)
+    static Void OutputLine(const TChar *pName, const TChar sep, const TChar *pWidthString, const TChar *pSubClassStr, const SStat &sCABAC, const SStat &sEP)
     {
       printf("%c%-45s%c  %6s %6s %12lld %12lld %12lld %12lld %12lld %12lld %12lld (%12lld)%c\n",
@@ -308,5 +308,5 @@
               sCABAC.count, sCABAC.sum, sCABAC.bits, sEP.count, sEP.sum, sEP.bits, sCABAC.bits+sEP.bits, (sCABAC.bits+sEP.bits)/8, sep=='~'?']':' ');
     }
-    static Void OutputLine(const Char *pName, const Char sep, const Char *pWidthString, const Char *pSubClassStr,  const SStat &sEP)
+    static Void OutputLine(const TChar *pName, const TChar sep, const TChar *pWidthString, const TChar *pSubClassStr,  const SStat &sEP)
     {
       printf("%c%-45s%c  %6s %6s %12s %12s %12s %12lld %12lld %12lld %12lld (%12lld)%c\n",
@@ -315,5 +315,5 @@
     }
 
-    static Void OutputDashedLine(const Char *pText)
+    static Void OutputDashedLine(const TChar *pText)
     {
       printf("--%s",pText);
@@ -360,5 +360,5 @@
         SStat cabacSubTotal, epSubTotal;
         Bool bHadClassifiedEntry=false;
-        const Char *pName=getName(TComCodingStatisticsType(i));
+        const TChar *pName=getName(TComCodingStatisticsType(i));
 
         for(UInt c=0; c<CODING_STATS_NUM_SUBCLASSES; c++)
@@ -488,5 +488,5 @@
     static SStat &GetStatisticEP(const std::string &str) { return GetSingletonInstance().data.mappings_ep[str]; }
 
-    static SStat &GetStatisticEP(const Char *pKey) {return GetStatisticEP(std::string(pKey)); }
+    static SStat &GetStatisticEP(const TChar *pKey) {return GetStatisticEP(std::string(pKey)); }
 
     static Void IncrementStatisticEP(const TComCodingStatisticsClassType &stat, const Int numBits, const Int value)
@@ -506,5 +506,5 @@
     }
 
-    static Void IncrementStatisticEP(const Char *pKey, const Int numBits, const Int value)
+    static Void IncrementStatisticEP(const TChar *pKey, const Int numBits, const Int value)
     {
       SStat &s=GetStatisticEP(pKey);
